<?php include_once('library.inc.php'); ?>
<!DOCTYPE html>
<html lang="en">
<head>
	<title>My DVD Library</title>
	<link href="/assets/css/bootstrap.min.css" rel="stylesheet">
	<link href="/assets/css/custom.css" rel="stylesheet">
	<script src="http://code.jquery.com/jquery-latest.js"></script>
	<script src="/assets/js/bootstrap.min.js"></script>
</head>
<body>
	<div class="container">
	    <div class="page-header">
	    	<h1>My DVD Library</h1>
	    </div>
	
		<ul class="nav nav-tabs">
			<li class="<?php if(!isset($_GET['type'])) echo 'active'; ?>"><a href="/">All DVDs</a></li>
			<li class="<?php if(isset($_GET['type']) && $_GET['type'] == 'borrowed') echo 'active'; ?>"><a href="/?type=borrowed">Borrowed</a></li>
		</ul>
	
		<div class="well well-small">
			Showing DVDs: <?php echo ($dvds['total'] > 0)? '1' : '0'; ?>-<?php echo $dvds['total']; ?> of <?php echo $dvds['total']; ?>
		</div>
	
		<table class="table table-hover table-bordered" id="history">
			<thead>
				<tr>
					<th>Title</th>
					<th>Borrowed By</th>
					<th>Borrowed On</th>
					<th>Options</th>
				</tr>
			</thead>
			<tbody>
				<?php if(count($dvds['library']) > 0): ?>
				<?php foreach($dvds['library'] as $dvd): ?>
				<tr>
					<td><?php echo $dvd['title']; ?></td>
					<td id="dvd-borrower"><?php echo $dvd['borrower']; ?></td>
					<td id="dvd-borrowed-date"><?php if($dvd['borrowed_date']) echo date('jS F Y', strtotime($dvd['borrowed_date'])); ?></td>
					<td id="dvd-options">
						<a href="#editModal-<?php echo $dvd['id']; ?>" role="button" class="btn btn-small btn-primary" data-toggle="modal">Edit</a>
						<a href="/?action=delete&amp;dvd-id=<?php echo $dvd['id']; ?>" class="btn btn-small btn-danger">Delete</a>
					</td>
				</tr>
				<?php endforeach; ?>
				<?php else: ?>
				<tr>
					<td colspan="4" class="copy-centered">Sorry, there are currently no DVDs to display</td>
				</tr>
				<?php endif; ?>
			</tbody>
    	</table>

		<form method="post" class="form-inline">
	    	<input type="text" name="title" placeholder="Enter DVD Title..." class="span6" />
			<input type="hidden" name="action" value="add" />
			<button type="submit" class="btn btn-primary">Add DVD</button>
		</form>
	</div>
	
	<?php if(count($dvds['library']) > 0): ?>
	<?php foreach($dvds['library'] as $dvd): ?>
	<div class="modal hide" id="editModal-<?php echo $dvd['id']; ?>" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
		<div class="modal-header">
			<button type="button" class="close" data-dismiss="modal" aria-hidden="true">x</button>
			<h3>Edit DVD</h3>
		</div>
		
		<div class="modal-body">
			<form method="post">
				<label><strong>Title</strong></label>
		    	<input type="text" name="title" value="<?php echo $dvd['title']; ?>" class="span6" /><br /><br />
		
				<label><strong>Borrowed By</strong></label>
				<input type="text" name="borrower" value="<?php echo $dvd['borrower']; ?>" class="span4" /><br /><br />
				
				<label><strong>Borrowed On</strong></label>
				<input type="text" name="borrowed_date" value="<?php echo $dvd['borrowed_date']; ?>" placeholder="YYYY-MM-DD" class="span2" /><br /><br />
				
				<input type="hidden" name="action" value="edit" />
				<input type="hidden" name="dvd-id" value="<?php echo $dvd['id']; ?>" />
				<button type="submit" class="btn btn-primary">Edit DVD</button>
		    </form>		
		</div>
		
		<div class="modal-footer">
			<button class="btn" data-dismiss="modal" aria-hidden="true">Cancel</button>
		</div>
	</div>
	<?php endforeach; ?>
	<?php endif; ?>
</body>
</html>