<?php

// Prepare our DVDs array
$dvds = array('total' => 0, 'library' => array());

// Define our database parameters
$dbHost = '127.0.0.1';
$dbUsername = 'dvdlibrary';
$dbPassword = 'dvdlibrary';
$dbDatabase = 'dvd-library';

// Connect to the MySQL database
$mysqli = mysqli_connect($dbHost, $dbUsername, $dbPassword, $dbDatabase);
if(mysqli_connect_errno($mysqli)) die('Failed to connect to MySQL: ' . mysqli_connect_error());

// Are we adding a DVD?
if(isset($_POST['action']) && $_POST['action'] == 'add') {
	$sqlQuery = mysqli_query($mysqli, "INSERT INTO dvds (title) VALUES ('" . mysqli_real_escape_string($mysqli, $_POST['title']) . "')");
}

// Are we editing the DVD?
if(isset($_POST['action']) && $_POST['action'] == 'edit') {
	// Sanitise and prepare our data
	$dvd_id = mysqli_real_escape_string($mysqli, $_POST['dvd-id']);
	$dvd_title = mysqli_real_escape_string($mysqli, $_POST['title']);
	$dvd_borrower = mysqli_real_escape_string($mysqli, $_POST['borrower']);
	$dvd_borrowed_date = mysqli_real_escape_string($mysqli, $_POST['borrowed_date']);
	
	// Perform the full SQL Query and update the DVD!
	$sqlQuery = mysqli_query($mysqli, "UPDATE dvds SET title = '" . $dvd_title . "', borrower = '" . $dvd_borrower . "', borrowed_date = '" . $dvd_borrowed_date . "' WHERE id = '" . $dvd_id . "'");
}

// Are we deleting the DVD?
if(isset($_GET['action']) && $_GET['action'] == 'delete') {
	$sqlQuery = mysqli_query($mysqli, "DELETE FROM dvds WHERE id = '" . mysqli_real_escape_string($mysqli, $_GET['dvd-id']) . "' LIMIT 1");
}

/* BY DEFAULT WE WANT TO VIEW THE LIBRARY AFTER ANY ACTION HAS TAKEN PLACE -- OR AS A FALLBACK TO NO ACTION */

// Check what display "type" we want...
if(isset($_GET['type']) && $_GET['type'] == 'borrowed') {
	$sqlQuery = mysqli_query($mysqli, "SELECT * FROM dvds WHERE borrowed_date != '0000-00-00' ORDER BY borrowed_date ASC");
}
else {
	$sqlQuery = mysqli_query($mysqli, "SELECT * FROM dvds ORDER BY title ASC");
}

// Check we've got a valid response back
if(is_numeric(mysqli_num_rows($sqlQuery)) && mysqli_num_rows($sqlQuery) > 0)
{
	// Add in the count (for an easy reference)
	$dvds['total'] = mysqli_num_rows($sqlQuery);

	// Loop through the results and store them in an array
	while($dvd_item = mysqli_fetch_array($sqlQuery)) 
	{
		// Store in our localised array
		$dvds['library'][] = array(
			'id' => $dvd_item['id'],
			'title' => stripslashes($dvd_item['title']),
			'borrower' => stripslashes($dvd_item['borrower']),
			'borrowed_date' => ($dvd_item['borrowed_date'] == '0000-00-00')? '' : $dvd_item['borrowed_date'],
		);
	}
}

// Be kind and end the connection
mysqli_close($mysqli);

?>